//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//MAINWND.CPP - Code for the CMainWnd object
//Copyright Marshall Harnish /97
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

#include "mainwnd.h"

//Define a message map for the CMainWnd object.
// Used to handle mouse clicks, etc
BEGIN_MESSAGE_MAP(CMainWnd,CFrameWnd)
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	ON_WM_NCHITTEST()
	ON_WM_KEYDOWN()
	ON_WM_SYSKEYDOWN()
	ON_WM_ERASEBKGND()
END_MESSAGE_MAP()

BOOL CMainWnd::OnEraseBkgnd( CDC* pDC )
{
	if(Running == TRUE)
	{
		m_DX->FlipSurfaces();
	}
	return(1);
}


void CMainWnd::OnSysKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags )
{
}

void CMainWnd::OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags )
{
	switch(nChar) 
	{
	case VK_ESCAPE:
		PostMessage(WM_CLOSE,0,0);
		break;
	case 'T':
		if(UserStatus==EDITOR)
			UserStatus=DISPLAYTILESET;
		break;
	case VK_F12:  //if the user invokes the editor
		switch(UserStatus){
		case EDITOR:
				UserStatus=DISPLAYMAINMAP;
			break;
		case MAINMAP:
				UserStatus=DISPLAYEDITOR;
			break;
		}
		break;
	case 'N':
		if(UserStatus==EDITOR)
		{
			m_Game->CreateNewMap(CurrentMap);
			m_Game->RedrawEditor(m_DX);
		}
		break;
	case 'S':
		m_Game->SaveEditorMap(CurrentMap);
		break;
	case 'Q':
		if(UserStatus==FIGHT)
		{
		    //temporary until i get fighting working fully
			m_Game->LoadMapTiles(CurrentTileSet, m_DX);
			m_Game->SetVariables();
			m_Game->RedrawMap(m_DX);
			UserStatus=MAINMAP;
			break;
		}
		else
		{
			UserStatus=DISPLAYMAINSCREEN;  //the 'reset' button
		}
		break;
	case VK_UP:
	case VK_DOWN:
	case VK_RIGHT:   ///Sends the key pressed to the Keyhandler in CGame
	case VK_LEFT:
		if(UserStatus==EDITOR)
		{
			m_Game->KeyHandle(nChar, UserStatus);
			m_Game->RedrawEditor(m_DX);
		}
		if(UserStatus==MAINMAP)
		{
			m_Game->KeyHandle(nChar, UserStatus);
			m_Game->RedrawMap(m_DX);
			if(m_Game->CheckMonsterHit(m_DX)==TRUE)
				UserStatus=DISPLAYFIGHT;
		}
		break;
	}
}

void CMainWnd::ParseIdle()
{
	switch(UserStatus)
	{
	case TITLESCREEN:
	
		m_Game->FadeInHalf("bmp\\logo320.bmp",m_DX);		m_Game->FadeOutHalf("bmp\\logo320.bmp",m_DX);
		m_Game->FadeInHalf("bmp\\merprod.bmp",m_DX);
		m_Game->FadeOutHalf("bmp\\merprod.bmp",m_DX);
		m_Game->FadeInHalf("bmp\\mercreat.bmp",m_DX);
		m_Game->FadeOutHalf("bmp\\mercreat.bmp",m_DX);
		m_Game->FadeInHalf("bmp\\cdxcred.bmp",m_DX);
		m_Game->FadeOutHalf("bmp\\cdxcred.bmp",m_DX);
		UserStatus=DISPLAYMAINSCREEN;  
		
//		UserStatus=DISPLAYMAINMAP;
		break;
	case DISPLAYMAINSCREEN:
		m_Game->FadeInTwist("bmp\\main320.bmp", m_DX);
		m_Game->DisplayTinyLogo("bmp\\logotiny.bmp", 530, 420, m_DX);
		UserStatus=MAINSCREEN;
		break;
	case MAINSCREEN:
		
		break;
	case DISPLAYMAINMAP:
		m_Game->LoadMap(CurrentMap);
		m_Game->LoadMapTiles("tiles\\map.bmp", m_DX);
		m_Game->SetVariables();
		m_Game->RedrawMap(m_DX);
		UserStatus=MAINMAP;
		break;
	case MAINMAP:

		break;
	case DISPLAYFIGHT:
		m_Game->Fight(CurrentTileSet, m_DX);
		m_DX->LoadBitmap(CurrentTileSet,CDX_TILES,0,0);
		UserStatus=FIGHT;
		break;
	case FIGHT:
		
		break;
	case NOTHING:
		break;
	case DISPLAYEDITOR:
//		m_Game->LoadMap(CurrentMap);
//		m_Game->LoadMapTiles("tiles\\map.bmp",m_DX);
		m_Game->RedrawEditor(m_DX);
		UserStatus=EDITOR;
		break;
	case EDITOR:
		break;
	case DISPLAYTILESET:
		m_DX->LoadBitmap(CurrentTileSet,CDX_BACK,0,0);
		m_DX->FlipSurfaces();
		UserStatus=TILESET;
		break;
	case TILESET:
		break;
	}
}

//Called whenever hte user clicks on the right button

void CMainWnd::OnRButtonDown(UINT Flags,CPoint ClickPT)
{
}

//Called whenever the user clicks the left button
void CMainWnd::OnLButtonDown(UINT Flags,CPoint ClickPT)
{
	if(UserStatus==EDITOR)
	{
		m_Game->ChangeMapTile(ClickPT, SelectedTile);
		m_Game->RedrawEditor(m_DX);
	}

	if(UserStatus==TILESET)
	{
		SelectedTile=m_Game->ChangeCurrentTile(CurrentTileSet, SelectedTile, ClickPT);
		UserStatus=DISPLAYEDITOR;		
	}

	if(UserStatus==MAINSCREEN)    //the minus is in account for the missing title bars, etc.
	{							  //The first number is the point * 2
		if(ClickPT.x>200)
			if(ClickPT.x<450)  //See if the user hit EXIT
				if(ClickPT.y>420)
					if(ClickPT.y<475)
		{
			PostMessage(WM_CLOSE,0,0);
		}

		if(ClickPT.x>150)
			if(ClickPT.x<490)  //See if the user hit Load Game
					if(ClickPT.y>350)
						if(ClickPT.y<400)
		{
		//	PostMessage(WM_CLOSE,0,0);
		}
		
		if(ClickPT.x>160)  
			if(ClickPT.x<490)  //See if the user hit New Game
					if(ClickPT.y>290)
						if(ClickPT.y<330)
		{
			UserStatus=DISPLAYMAINMAP;
		//	PostMessage(WM_CLOSE,0,0);
		}
	}
}

UINT CMainWnd::OnNcHitTest( CPoint point )
{
	return HTCLIENT;
}

//The constructor... called upon creation of the CMainWnd object
CMainWnd::CMainWnd()
{
	CurrentMap="map\\map.dat";
	CurrentTileSet="tiles\\map.bmp";
	SelectedTile=0;  //Sets the selected tile for the editor to zero

	//Cause the window to Create itself (easier than doing it in CMainApp)
	Create(NULL,"Final Fantasy Z",WS_POPUP|WS_EX_TOPMOST|WS_VISIBLE,CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y));

	//Create a DirectDraw object and set the video mode
	m_DX = new CDX();
	m_Game = new CGame();
	if(!(m_DX->Create(SCN_SIZE_X,SCN_SIZE_Y,16)))
	{
		AfxMessageBox("Couldn't create!\n");
		return;
	}
/*

		POINT DestPt;
		DestPt.x=0;		//Set it up to start at 0,0
		DestPt.y=0;
		ClientToScreen(&DestPt);

	if(m_DX->GetVideoMode()>480)
	{
		/////////////////////////////////////////////////
		//Figure out the offset of the window/border
		//(Used to make the client area equal to the screen size)
		//Convert the client area starting to screen coords
		//Resize the window so that the client area is SCN_SIZE_X/SCN_SIZE_Y
		SetWindowPos(&wndTopMost,0,0,SCN_SIZE_X+(DestPt.x << 1),SCN_SIZE_Y+(DestPt.y+DestPt.x),SWP_SHOWWINDOW);
	}
		else
//			SetWindowPos(&wndTopMost,0,0,SCN_SIZE_X,SCN_SIZE_Y+(DestPt.y),SWP_SHOWWINDOW);
		SetWindowPos(&wndTopMost,0,0,SCN_SIZE_X+(DestPt.x << 1),SCN_SIZE_Y+(DestPt.y+DestPt.x),SWP_SHOWWINDOW);
*/	
	Running=TRUE;
	UserStatus=TITLESCREEN;  //wtf do you think it does
}

//The destructor... called upon destruction of the CMainWnd object
CMainWnd::~CMainWnd()
{
	if(m_DX)
		delete m_DX;	//Delete the CDX object
	if(m_Game)
		delete m_Game;  /////Deletes the m_GAME object
}
